#include<iostream>
using namespace std;

long long dani[300100], plazme[300100], kolicine[300100];

long long sracunaj(long long upit, int j){
   if(plazme[j]<upit-dani[j]+1)
      return plazme[j];
   else
      return upit-dani[j]+1;
}

int main(){
   long long n, q;
   cin>>n>>q;
   for(int i=0; i<n; i++){
      cin>>dani[i];
      cin>>plazme[i];
   }

   long long upit, trenutna_kolicina=0;
   for(int i=0; i<q; i++){
      cin>>upit;
      for(int j=0; j<n; j++){
         if(dani[j]<=upit){
            trenutna_kolicina+=sracunaj(upit, j);
         }
         else
            break;
      }
      kolicine[i]=trenutna_kolicina;
      trenutna_kolicina=0;
   }
   for(int i=0; i<q; i++)
      cout<<kolicine[i]<<endl;
    return 0;
}